/*
* Setup process sandbox
*
* Copyright (C) 2014 - Brian Caswell <bmc@lungetech.com>
*
* Permission is hereby granted, free of charge, to any person obtaining a copy
* of this software and associated documentation files (the "Software"), to deal
* in the Software without restriction, including without limitation the rights
* to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
* copies of the Software, and to permit persons to whom the Software is
* furnished to do so, subject to the following conditions:
*
* The above copyright notice and this permission notice shall be included in
* all copies or substantial portions of the Software.
*
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
* THE SOFTWARE.
*/

#include <stdlib.h>
#include <sys/resource.h>

#include "resources.h"
#include "utils.h"

void setup_sandbox(void) {
    struct rlimit rlim;
    rlim.rlim_cur = 0;
    rlim.rlim_max = 0;

    VERIFY(setrlimit, RLIMIT_MSGQUEUE, &rlim);
    VERIFY(setrlimit, RLIMIT_LOCKS, &rlim);
    VERIFY(setrlimit, RLIMIT_MEMLOCK, &rlim);

    rlim.rlim_cur = 8 * 1024 * 1024;
    rlim.rlim_max = rlim.rlim_cur;
    VERIFY(setrlimit, RLIMIT_STACK, &rlim);

    rlim.rlim_cur = 1024 * 1024 * 1024;
    rlim.rlim_max = rlim.rlim_cur;
    VERIFY(setrlimit, RLIMIT_DATA, &rlim);
}

void set_nofiles(void) {
    struct rlimit rlim;
    rlim.rlim_cur = 0;
    rlim.rlim_max = 0;

    VERIFY(setrlimit, RLIMIT_NOFILE, &rlim);
}

void set_core_size(int size) {
    struct rlimit rlim = {size, size};

    VERIFY(setrlimit, RLIMIT_CORE, &rlim);
}
